; #########################################################################

      .386
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include calc.inc          ; local includes for this file


    .data
        szDisplayName db "Calculator Template",0

    .code

XX  MACRO sym, x, y, w, h, color, func

func proc hWin:DWORD, hKey:DWORD
    invoke MessageBox,hWin,hKey,
           ADDR szDisplayName,MB_OK
    ret
func endp

    ENDM

    geometry

    .data

; #########################################################################

    .data
    statClass db "STATIC",0
    CommandLine   dd 0
    hWnd          dd 0
    hInstance     dd 0
    hIcon         dd 0

key STRUCT
    sym   db 8 dup (0)
    x     dd 0
    y     dd 0
    w     dd 0
    h     dd 0
    color dd 0
    func  dd 0
key ENDS

XX  MACRO s, x, y, w, h, c, fn
    key  <s, x, y, w, h, c, fn>
    ENDM

table      equ $
         geometry
tablelim   equ $

.code

start:
      invoke GetModuleHandle, NULL
      mov hInstance, eax

      invoke GetCommandLine
      mov CommandLine, eax

      invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
      invoke ExitProcess,eax

; #########################################################################

WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             CmdLine   :DWORD,
             CmdShow   :DWORD

      ;====================
      ; Put LOCALs on stack
      ;====================

      LOCAL wc   :WNDCLASSEX
      LOCAL msg  :MSG
      LOCAL Wwd  :DWORD
      LOCAL Wht  :DWORD
      LOCAL Wtx  :DWORD
      LOCAL Wty  :DWORD

      ;==================================================
      ; Fill WNDCLASSEX structure with required variables
      ;==================================================

      invoke LoadIcon,hInst,1    ; icon ID
      mov hIcon, eax

      szText szClassName,"Calculator_Template_Class"

      mov wc.cbSize,         sizeof WNDCLASSEX
      mov wc.style,          CS_HREDRAW or CS_VREDRAW \
                             or CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc,    offset WndProc
      mov wc.cbClsExtra,     NULL
      mov wc.cbWndExtra,     NULL
      m2m wc.hInstance,      hInst
      mov wc.hbrBackground,  COLOR_BTNFACE+1
      mov wc.lpszMenuName,   NULL
      mov wc.lpszClassName,  offset szClassName
      m2m wc.hIcon,          hIcon
      invoke LoadCursor,NULL,IDC_ARROW
      mov wc.hCursor,        eax
      m2m wc.hIconSm,        hIcon

      invoke RegisterClassEx, ADDR wc

      ;================================
      ; Centre window at following size
      ;================================

      mov Wwd, WWIDTH
      mov Wht, WHEIGHT

      invoke GetSystemMetrics,SM_CXSCREEN
      invoke TopXY,Wwd,eax
      mov Wtx, eax

      invoke GetSystemMetrics,SM_CYSCREEN
      invoke TopXY,Wht,eax
      mov Wty, eax

      invoke CreateWindowEx,WS_EX_LEFT,
                            ADDR szClassName,
                            ADDR szDisplayName,
                            WS_OVERLAPPED or WS_SYSMENU,
                            Wtx,Wty,Wwd,Wht,
                            NULL,NULL,
                            hInst,NULL
      mov   hWnd,eax

      invoke LoadMenu,hInst,600  ; menu ID
      invoke SetMenu,hWnd,eax

      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd

      ;===================================
      ; Loop until PostQuitMessage is sent
      ;===================================

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:

      return msg.wParam

WinMain endp

; #########################################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL hStatImage :DWORD
    LOCAL hBmp   :DWORD
    LOCAL Rct    :RECT
    LOCAL hDC    :DWORD
    LOCAL Ps     :PAINTSTRUCT
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

    .if uMsg == WM_COMMAND

        .if wParam == 400
        szText icoMsg1,"Single Icon Button"
            invoke MessageBox,hWin,ADDR icoMsg1,
                              ADDR szDisplayName,MB_OK
        .endif

    .elseif uMsg == WM_LBUTTONDOWN
        invoke LButtonDown,hWin,uMsg,wParam,lParam
        return 0
    .elseif uMsg == WM_LBUTTONUP
        invoke LButtonUp,hWin,uMsg,wParam,lParam
        return 0
    .elseif uMsg == WM_CREATE

        ; ---------------------------------------
        ; Setting the top X and Y co-ordinate are
        ; the only ones that matter. Loading the
        ; bitmap into the control auto-sizes the
        ; control to the size of the bitmap.
        ; ---------------------------------------
        invoke StaticImage,NULL,hWin,LEFT,TOP,LEFT,TOP,65535
        mov hStatImage, eax

        ; --------------------------------------
        ; load the bitmap from the resource file
        ; --------------------------------------
        invoke LoadBitmap,hInstance,750
        mov hBmp, eax   ; put the return value into a DWORD variable

        ; -------------------------------------
        ; Set the image into the static control
        ; -------------------------------------
        invoke SendMessage,hStatImage,STM_SETIMAGE,IMAGE_BITMAP,hBmp

    .elseif uMsg == WM_SIZE

    .elseif uMsg == WM_PAINT
        invoke BeginPaint,hWin,ADDR Ps
        mov hDC, eax
        invoke Paint_Proc,hWin,hDC
        invoke EndPaint,hWin,ADDR Ps
        return 0

    .elseif uMsg == WM_CLOSE

    .elseif uMsg == WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0 
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

FindMsgKey proc hWin:DWORD

    LOCAL pos:POINT
    LOCAL msgpos:DWORD
    LOCAL msgbuf[128]:BYTE

    invoke GetMessagePos
    mov msgpos, eax
    and eax, 0FFFFh
    mov pos.x, eax
    mov eax, msgpos
    shr eax, 16
    mov pos.y, eax
    invoke ScreenToClient,hWin,ADDR pos

    sub pos.x, LEFT
    sub pos.y, TOP

;    szText btnFoundFmt,"Button at %d, %d"

;    invoke wsprintf, ADDR msgbuf,ADDR btnFoundFmt,pos.x,pos.y

;    invoke MessageBox,hWin,ADDR msgbuf,
;                      ADDR szDisplayName,MB_OK

    mov eax, offset table
@@: mov ecx, (key PTR [eax]).x
    mov edx, pos.x
    cmp ecx, edx
    jae next
    add ecx, (key PTR [eax]).w
    cmp ecx, edx
    jbe next

    mov ecx, (key PTR [eax]).y
    mov edx, pos.y
    cmp ecx, edx
    jae next
    add ecx, (key PTR [eax]).h
    cmp ecx, edx
    jbe next

    return eax

next:
    add eax, SIZEOF(key)
    cmp eax, tablelim
    jb @B
    return 0

FindMsgKey endp


LButtonDown proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    ret

LButtonDown endp

LButtonUp proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    invoke FindMsgKey, hWin

    .if eax!=0
      mov ecx,(key PTR [eax]).func
      push eax
      push hWin
      call ecx
      add esp,8
    .endif

    ret

LButtonUp endp

; ########################################################################

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp

; #########################################################################

Paint_Proc proc hWin:DWORD, hDC:DWORD

    LOCAL btn_hi   :DWORD
    LOCAL btn_lo   :DWORD
    LOCAL Rct      :RECT

    invoke GetSysColor,COLOR_BTNHIGHLIGHT
    mov btn_hi, eax

    invoke GetSysColor,COLOR_BTNSHADOW
    mov btn_lo, eax

    return 0

Paint_Proc endp

StaticImage proc lpText:DWORD,hParent:DWORD,
                 a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,ID:DWORD

; invoke StaticImage,NULL,hWnd,20,20,100,25,500

    invoke CreateWindowEx,WS_EX_STATICEDGE,
            ADDR statClass,lpText,
            WS_CHILD or WS_VISIBLE or SS_BITMAP,
            a,b,wd,ht,hParent,ID,
            hInstance,NULL

    ret

StaticImage endp

end start
